
--TODO: Rename vgui variables.

MsgN("Henry's Animation Tools Client Initiated")

local PlayButton
local StopButton
local RecordButton
local ClearButton
local AddButton
local RemoveButton
local HATPanel
local ButtonHoverEffect

if hanim.GUILoaded then

	hanim.GUISettings()
	
end

local function HATOnGamemodeLoaded()

	hanim.GUILoaded = true
	hanim.CurFrame = 1
	HATPanel = vgui.Create('DPanel')
	KeyFramesPanel = vgui.Create('DPanel')
	KeyFramesPanelList = vgui.Create('DPanel')
	KeyFramesList = vgui.Create('DPanelList')
	HorizontalScrollbar = vgui.Create('DHScrollBar')
	HorizontalScrollbar:SetParent(KeyFramesPanel)
	HorizontalScrollbar:SetSize(600, 15)
	HorizontalScrollbar:SetPos(5, 35)
	HorizontalScrollbar:SetScrollPanel(KeyFramesList)
	PlayButton = vgui.Create('DButton')
	StopButton = vgui.Create('DSysButton')
	RecordButton = vgui.Create('DSysButton')
	ClearButton = vgui.Create('DSysButton')
	AddButton = vgui.Create('DButton')
	RemoveButton = vgui.Create('DButton')
	
	// My god this is so hacky.
	ButtonHoverEffect = vgui.Create('DButton')
	ButtonHoverEffect:SetText(" ")
	ButtonHoverEffect.OnMouseReleased = function()
		ButtonHoverEffect:SetMouseInputEnabled(true)
		ButtonHoverEffect:KillFocus()
		ButtonHoverEffect:MouseCapture(false)
	end
	ButtonHoverEffect:OnMousePressed()
	ButtonHoverEffect:SetVisible(false)
	
	
	KeyFrames = {}
	
	--[[for i=1,10 do
		KeyFrames[i] = vgui.Create('DButton')
		KeyFrames[i]:SetSize(15, 25)
		KeyFrames[i]:SetText(" ")
		KeyFrames[i]:SetToolTip(" "..i.." ")
		KeyFrames[i].n = i
		KeyFrames[i].DoClick = function(self)
		
		end
		KeyFrames[i].PaintOver = function(self)
			if math.fmod(self.n,5) == 0 then
				draw.RoundedBox(4, 1, 1, self:GetWide()-2, self:GetTall()-2, Color(100, 171, 221, 100))
			end
		end
		KeyFramesList:AddItem(KeyFrames[i])
		KeyFramesList:SetSize(i*15,25)
		HorizontalScrollbar:SetGripSize(i*15,600)
	end]]
	
	//Create the first keyframe.
	hanim.CreateKeyframe()
	
	hanim.GUISettings()
	
end
hook.Add("OnGamemodeLoaded","HAT_OnGamemodeLoaded",HATOnGamemodeLoaded)

function hanim.GUISettings()

	HATPanel:SetSize(620, 95)
	HATPanel:SetPos(5, ScrH()-100)
	
	KeyFramesPanel:SetParent(HATPanel)
	KeyFramesPanel:SetSize(610, 55)
	KeyFramesPanel:SetPos(5, 5)
	KeyFramesPanel.Paint = function(self)
		draw.RoundedBox(4, 0, 0, self:GetWide(), self:GetTall(), Color(52, 54, 59, 255))
	end
	
	KeyFramesPanelList:SetParent(KeyFramesPanel)
	KeyFramesPanelList:SetSize(600, 25)
	KeyFramesPanelList:SetPos(5, 5)
	KeyFramesPanelList:SetPaintBackground(false)
	
	KeyFramesList:SetParent(KeyFramesPanelList)
	//KeyFramesList:SetSize(600, 25)
	KeyFramesList:SetPos(0, 0)
	KeyFramesList:EnableHorizontal(true)
	KeyFramesList:SetDrawBackground(true)
	
	PlayButton:SetParent(HATPanel)
	PlayButton:SetSize(70, 25)
	PlayButton:SetPos(5, 65)
	PlayButton:SetText("Play")
	PlayButton.DoClick = function() hanim.Play() end
	
	StopButton:SetParent(HATPanel)
	StopButton:SetToolTip("Stop")
	StopButton:SetSize(40, 25)
	StopButton:SetPos(80, 65)
	StopButton:SetChar("g")
	StopButton.DoClick = function() hanim.Stop() end
	
	RecordButton:SetParent(HATPanel)
	RecordButton:SetToolTip("Record Single Frame")
	RecordButton:SetSize(40, 25)
	RecordButton:SetPos(125, 65)
	RecordButton:SetChar("h")
	RecordButton.DoClick = function() hanim.RecordFrame(hanim.CurFrame) end
	
	ClearButton:SetParent(HATPanel)
	ClearButton:SetToolTip("Clear Frame")
	ClearButton:SetSize(40, 25)
	ClearButton:SetPos(170, 65)
	ClearButton:SetChar("r")
	ClearButton.DoClick = function() hanim.ClearFrame(hanim.CurFrame) end

	AddButton:SetParent(HATPanel)
	AddButton:SetToolTip("Add Frame")
	AddButton:SetSize(40, 25)
	AddButton:SetPos(215, 65)
	AddButton:SetText("+")
	AddButton.DoClick = function()
		hanim.AddFrame()
	end
	
	RemoveButton:SetParent(HATPanel)
	RemoveButton:SetToolTip("Remove Last Frame")
	RemoveButton:SetSize(40, 25)
	RemoveButton:SetPos(260, 65)
	RemoveButton:SetText("-")
	RemoveButton.DoClick = function()
		hanim.RemoveFrame()
	end
	
	FrameWang = vgui.Create('DNumberWang')
	FrameWang:SetParent(HATPanel)
	FrameWang:SetToolTip("Single Frame Length (in seconds)")
	FrameWang:SetPos(555, 65)
	FrameWang:SetDecimals(2)
	FrameWang:SetFraction(2)
	FrameWang.OMR = FrameWang.OnMouseReleased
	FrameWang.OnMouseReleased = function(self,mc)
		self:OMR(mc)
		hanim.SetCurFrameLength(self:GetValue())
	end
	//FrameWang.OnValueChanged = function() end
	FrameWang:SetValue(0.5)
	FrameWang:SetMinMax( 0, 50)
	FrameWang:SetWide(60)

	HorizontalScrollbar:SetVisible(false)
	HATPanel:SetVisible(false)
	
end

function hanim.CreateKeyframe()
	k = #KeyFrames + 1
	local b = vgui.Create('DButton')
	b:SetSize(15, 25)
	b:SetText(" ")
	b:SetToolTip(" "..tostring(k).." ")
	b.n = k
	b.DoClick = function(self) hanim.SetFrame(self.n) end
	b.PaintOver = function(self)
		if math.fmod(self.n,5) == 0 then
			draw.RoundedBox(4, 1, 1, self:GetWide()-2, self:GetTall()-2, Color(100, 171, 221, 50))
		end
		if hanim.CurFrame == self.n then
			paintButtonHover(self:GetWide(),self:GetTall())
		end
	end
	KeyFrames[k] = b
	KeyFramesList:AddItem(KeyFrames[k])
	KeyFramesList:SetSize(k*15,25)
	HorizontalScrollbar:SetGripSize(k*15,600)
end

//What this does is that it paints a "hover" button effect.
//This is an extremely hacky method since I can't seem to find the source code for buttons.
function paintButtonHover(x,y)
	ButtonHoverEffect:SetSize(x,y)
	ButtonHoverEffect:Paint()
end

//////////////////////////////////////////////////////////////////////////////////////////////////////

function hanim.SetFrame(n)

	datastream.StreamToServer( "hanimSetFrame", {n}, function() end )

end

function hanim.RecordFrame(n)

	datastream.StreamToServer( "hanimRecordFrame", {n,FrameWang:GetValue()}, function() end )

end

function hanim.ClearFrame(n)

	datastream.StreamToServer( "hanimClearFrame", {n}, function() end )

end

function hanim.Play()

	datastream.StreamToServer( "hanimPlay", {}, function() end )
	
end

function hanim.Stop(n)

	datastream.StreamToServer( "hanimStop", {n}, function() end )

end

function hanim.SetCurFrameLength(n)

	datastream.StreamToServer( "hanimSetCurFrameLength", {hanim.CurFrame,n}, function() end )

end

function hanim.SetClFrame( hand, id, encoded, decoded )
	hanim.CurFrame = decoded[1]
	if decoded[2] then
		FrameWang:SetValue(decoded[2])
	end
end
datastream.Hook( "hanimClSetFrame", hanim.SetClFrame )

function hanim.AddFrame()
	datastream.StreamToServer( "hanimAddFrame", {}, function() end )
end

function hanim.RemoveFrame()
	datastream.StreamToServer( "hanimRemoveFrame", {}, function() end )
end

function hanim.ClAddFrame( hand, id, encoded, decoded )
	hanim.CreateKeyframe()
end
datastream.Hook( "hanimClAddFrame", hanim.ClAddFrame )

function hanim.ClRemoveFrame( hand, id, encoded, decoded )
	k = #KeyFrames
	if KeyFrames[k] then
		if hanim.CurFrame == KeyFrames[k].n then
			hanim.SetFrame(hanim.CurFrame - 1)
		end
		KeyFrames[k]:Remove()
		KeyFramesList:RemoveItem(KeyFrames[k])
		KeyFramesList:SetSize((k-1)*15,25)
		HorizontalScrollbar:SetGripSize((k-1)*15,600)
		table.remove(KeyFrames,k)
	end
end
datastream.Hook( "hanimClRemoveFrame", hanim.ClRemoveFrame )

function hanim.MenuOpen(cmd,arg)

	RestoreCursorPosition()
	gui.EnableScreenClicker(true)
	HATPanel:SetVisible(true)
	HorizontalScrollbar:SetVisible(true)
	
end
concommand.Add("+HATMenu",hanim.MenuOpen)

function hanim.MenuClose(cmd,arg)
	
	RememberCursorPosition()
	gui.EnableScreenClicker(false)
	HorizontalScrollbar:SetVisible(false)
	HATPanel:SetVisible(false)
	
end
concommand.Add("-HATMenu",hanim.MenuClose)
